searchNodes=[{"doc":"Client library for accessing PRX APIs","ref":"PrxAccess.html","title":"PrxAccess","type":"module"},{"doc":"","ref":"PrxAccess.html#follow/2","title":"PrxAccess.follow/2","type":"function"},{"doc":"","ref":"PrxAccess.html#follow/3","title":"PrxAccess.follow/3","type":"function"},{"doc":"Get any resource by url","ref":"PrxAccess.html#get/2","title":"PrxAccess.get/2","type":"function"},{"doc":"","ref":"PrxAccess.html#link/2","title":"PrxAccess.link/2","type":"function"},{"doc":"","ref":"PrxAccess.html#link?/2","title":"PrxAccess.link?/2","type":"function"},{"doc":"","ref":"PrxAccess.html#links/2","title":"PrxAccess.links/2","type":"function"},{"doc":"","ref":"PrxAccess.html#rels/1","title":"PrxAccess.rels/1","type":"function"},{"doc":"Get the root resource for a hostname","ref":"PrxAccess.html#root/2","title":"PrxAccess.root/2","type":"function"},{"doc":"","ref":"PrxAccess.Auth.html","title":"PrxAccess.Auth","type":"module"},{"doc":"","ref":"PrxAccess.Auth.html#get_token/1","title":"PrxAccess.Auth.get_token/1","type":"function"},{"doc":"","ref":"PrxAccess.Error.html","title":"PrxAccess.Error","type":"module"},{"doc":"","ref":"PrxAccess.Error.html#build/3","title":"PrxAccess.Error.build/3","type":"function"},{"doc":"","ref":"PrxAccess.Error.html#for_resource/2","title":"PrxAccess.Error.for_resource/2","type":"function"},{"doc":"","ref":"PrxAccess.Remote.html","title":"PrxAccess.Remote","type":"module"},{"doc":"","ref":"PrxAccess.Remote.html#get/2","title":"PrxAccess.Remote.get/2","type":"function"},{"doc":"","ref":"PrxAccess.Remote.html#host_to_api/1","title":"PrxAccess.Remote.host_to_api/1","type":"function"},{"doc":"","ref":"PrxAccess.Remote.html#host_to_url/1","title":"PrxAccess.Remote.host_to_url/1","type":"function"},{"doc":"","ref":"PrxAccess.Remote.html#user_agent/0","title":"PrxAccess.Remote.user_agent/0","type":"function"},{"doc":"","ref":"PrxAccess.Resource.html","title":"PrxAccess.Resource","type":"module"},{"doc":"","ref":"PrxAccess.Resource.html#build/3","title":"PrxAccess.Resource.build/3","type":"function"},{"doc":"","ref":"PrxAccess.Resource.html#build/4","title":"PrxAccess.Resource.build/4","type":"function"},{"doc":"","ref":"PrxAccess.Resource.html#from_json/4","title":"PrxAccess.Resource.from_json/4","type":"function"},{"doc":"","ref":"PrxAccess.Resource.Link.html","title":"PrxAccess.Resource.Link","type":"module"},{"doc":"","ref":"PrxAccess.Resource.Link.html#from_json/1","title":"PrxAccess.Resource.Link.from_json/1","type":"function"},{"doc":"PrxAccess Elixir client library for accessing PRX HAL APIs.","ref":"readme.html","title":"PrxAccess","type":"extras"},{"doc":"Add the package to your list of dependencies in mix.exs: def deps do [ {:prx_access, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"PrxAccess - Installation","type":"extras"},{"doc":"To make requests against the a PRX API host, just provide the hostname and start navigating: {:ok, root} = PrxAccess.root(&quot;feeder.prx.org&quot;) # list link rels on this root document {:ok, rels} = PrxAccess.rels(root) # follow one of them! {:ok, podcasts} = PrxAccess.follow(root, &quot;prx:podcasts&quot;, page: 1, per: 1) IO.puts(podcasts.attributes[&quot;count&quot;]) IO.puts(podcasts.attributes[&quot;total&quot;]) # get items from this page {:ok, items} = PrxAccess.follow(podcasts, &quot;prx:items&quot;) Enum.each(items, fn(i) -&gt; IO.puts(i.attributes[&quot;title&quot;]) end) # follow off an item - woh, we&#39;re in CMS now! {:ok, account} = hd(items) |&gt; PrxAccess.follow(&quot;prx:account&quot;) IO.puts(podcasts._url) # https://feeder.prx.org/api/v1/podcasts?page=1&amp;per=1 IO.puts(account._url) # https://cms.prx.org/api/v1/accounts/5678 Authorization To make an authorized request, you&#39;ll need a PRX client_id and client_secret for id.prx.org. auth_options = [ account: 1234, id_host: &quot;id.staging.prx.tech&quot;, client_id: &quot;my-client-id&quot;, client_secret: &quot;my-client-secret&quot; ] {:ok, root} = PrxAccess.root(&quot;cms.staging.prx.tech&quot;, auth_options) # or maybe you want the /api/v1/authorization entry point {:ok, auth_root} = PrxAccess.follow(&quot;/api/v1/authorization&quot;) # or go directly there {:ok, auth_direct} = PrxAccess.get(&quot;https://cms.staging.prx.tech/api/v1/authorization&quot;, auth_options) Chaining Requests It&#39;s easy to chain together a bunch of HAL links, using elixir pipes. If any of your resources return a non-200, you&#39;ll get a %PrxAccess.Error{} returned for any subsequent link-follows: {:ok, podcast} = PrxAccess.root(&quot;feeder.prx.org&quot;) |&gt; PrxAccess.follow(&quot;prx:podcast&quot;, id: 70) # or an error {:error, err} = PrxAccess.root(&quot;feeder.prx.org&quot;) |&gt; PrxAccess.follow(&quot;prx:podcast&quot;, id: 70) |&gt; PrxAccess.follow(&quot;prx:whatev&quot;) |&gt; PrxAccess.follow(&quot;prx:these&quot;) |&gt; PrxAccess.follow(&quot;prx:arenot&quot;) |&gt; PrxAccess.follow(&quot;prx:called&quot;) IO.inspect(err) # %PrxAccess.Error{ # status: 200, # url: &quot;https://feeder.prx.org/api/v1/podcasts/70&quot;, # message: &quot;rel prx:whatev not found&quot; # }","ref":"readme.html#usage","title":"PrxAccess - Usage","type":"extras"},{"doc":"MIT License","ref":"readme.html#license","title":"PrxAccess - License","type":"extras"},{"doc":"Fork it Create your feature branch (git checkout -b my-new-feature) Commit your changes (git commit -am &#39;Add some feature&#39;) Push to the branch (git push origin my-new-feature) Create new Pull Request","ref":"readme.html#contributing","title":"PrxAccess - Contributing","type":"extras"}]